/******************************************************************************
 ElementInfo.h

	Nested ElementInfo class for JFileArrayIndex class

	Copyright  1994 John Lindal. All rights reserved.

 ******************************************************************************/

#ifndef _H_ElementInfo
#define _H_ElementInfo

// information about an element in a JFileArray

struct ElementInfo
	{
	JUnsignedOffset	offset;				// offset of data from start of file
	JFAID			id;					// unique id for element
	FAElementType	type;				// data or embedded file
	JFileArray*		theEmbeddedFile;	// NULL or pointer to open JFileArray object

	ElementInfo()
		:
		offset( 0 ),
		id( kInvalidFAID ),
		type( kData ),
		theEmbeddedFile( NULL )
		{ };

	ElementInfo
		(
		const JUnsignedOffset	anOffset,
		const JFAID&			anID,
		const FAElementType		aType
		)
		:
		offset( anOffset ),
		id( anID ),
		type( aType ),
		theEmbeddedFile( NULL )
		{ };
	};

#endif
