/******************************************************************************
 JComplex.h

	Defines clean complex number type

	Copyright  1997 by John Lindal. All rights reserved.

 ******************************************************************************/

#ifndef _H_JComplex
#define _H_JComplex

#include <jTypes.h>

#ifdef __VCPP__
	#include <complex>
	typedef complex<double>	JComplex;
#else
	#include <complex.h>
	typedef double_complex	JComplex;
#endif

class JString;

JComplex JAsin(const JComplex&);
JComplex JAcos(const JComplex&);
JComplex JAtan(const JComplex&);

enum JComplexDisplayMode
{
	kDisplayRealAndImag,
	kDisplayMagAndPhase
};

JComplexDisplayMode	JGetComplexDisplayMode();
void				JSetComplexDisplayMode(const JComplexDisplayMode mode);

JBoolean			JUsingEEImag();
void				JUseEEImag(const JBoolean useEEImag);
const JCharacter*	JGetCurrentImagString();
const JCharacter*	JGetMathImagString();
const JCharacter*	JGetEEImagString();

JString	JPrintComplexNumber(const JComplex& value);
JString	JPrintComplexNumber(const JComplex& value,
							const JComplexDisplayMode mode,
							const JBoolean useEEImag);

#endif
