/******************************************************************************
 jFStreamOpenModes.h

	Defines useful modes for opening fstreams.

	Copyright  1995 by John Lindal. All rights reserved.

 ******************************************************************************/

#ifndef _H_jFStreamOpenModes
#define _H_jFStreamOpenModes

#include <iostream.h>

#if defined __SC__

	typedef int JFStreamOpenMode;

	const JFStreamOpenMode kJBinaryFile = ios::in | ios::out;
	const JFStreamOpenMode kJTextFile   = ios::in | ios::out | ios::translated;

#elif defined __GNUG__

	typedef int JFStreamOpenMode;

	const JFStreamOpenMode kJBinaryFile = ios::in | ios::out | ios::bin;
	const JFStreamOpenMode kJTextFile   = ios::in | ios::out;

#elif __MWERKS__

	typedef ios::openmode JFStreamOpenMode;

	const JFStreamOpenMode kJBinaryFile = ios::in | ios::out | ios::binary;
	const JFStreamOpenMode kJTextFile   = ios::in | ios::out;

#elif defined __VCPP__

	typedef int JFStreamOpenMode;

	const JFStreamOpenMode kJBinaryFile = ios::in | ios::out | ios::binary;
	const JFStreamOpenMode kJTextFile   = ios::in | ios::out;

#else

	figure out what to do!

#endif

#endif
