/******************************************************************************
 JXDNDChooseDropActionDialog.h

	Interface for the JXDNDChooseDropActionDialog class

	Copyright  1998 by John Lindal. All rights reserved.

 ******************************************************************************/

#ifndef _H_JXDNDChooseDropActionDialog
#define _H_JXDNDChooseDropActionDialog

#include <JXDialogDirector.h>
#include <JPtrArray-JString.h>
#include <X11/X.h>

class JXRadioGroup;

class JXDNDChooseDropActionDialog : public JXDialogDirector
{
public:

	JXDNDChooseDropActionDialog(const JArray<Atom>& actionList,
								const JPtrArray<JString>& descriptionList);

	virtual ~JXDNDChooseDropActionDialog();

	Atom	GetAction() const;

private:

	const JArray<Atom>&	itsActionList;
	JXRadioGroup*		itsActionRG;

private:

	void	BuildWindow(const JPtrArray<JString>& descriptionList);

	// not allowed

	JXDNDChooseDropActionDialog(const JXDNDChooseDropActionDialog& source);
	const JXDNDChooseDropActionDialog& operator=(const JXDNDChooseDropActionDialog& source);
};

#endif
