/******************************************************************************
 JXEPSPrintSetupDialog.h

	Interface for the JXEPSPrintSetupDialog class

	Copyright  1997 by John Lindal. All rights reserved.

 ******************************************************************************/

#ifndef _H_JXEPSPrintSetupDialog
#define _H_JXEPSPrintSetupDialog

#include <JXDialogDirector.h>
#include <JXEPSPrinter.h>

class JXTextButton;
class JXStaticText;
class JXTextCheckbox;

class JXEPSPrintSetupDialog : public JXDialogDirector
{
public:

	JXEPSPrintSetupDialog(JXWindowDirector* supervisor, const JCharacter* fileName,
						  const JBoolean printPreview, const JBoolean bw);

	virtual ~JXEPSPrintSetupDialog();

	void	SetParameters(JXEPSPrinter* p) const;

protected:

	virtual JBoolean	OKToDeactivate();
	virtual void		Receive(JBroadcaster* sender, const Message& message);

private:

// begin JXLayout

    JXTextButton*   itsChooseFileButton;
    JXTextCheckbox* itsBWCheckbox;
    JXTextCheckbox* itsPreviewCheckbox;
    JXStaticText*   itsFileNameDisplay;

// end JXLayout

private:

	void	BuildWindow(const JCharacter* fileName,
						const JBoolean printPreview, const JBoolean bw);

	void	ChooseDestinationFile();

	// not allowed

	JXEPSPrintSetupDialog(const JXEPSPrintSetupDialog& source);
	const JXEPSPrintSetupDialog& operator=(const JXEPSPrintSetupDialog& source);
};

#endif
