/******************************************************************************
 JXFloatTableInput.h

	Interface for the JXFloatTableInput class

	Copyright  1996 by John Lindal. All rights reserved.

 ******************************************************************************/

#ifndef _H_JXFloatTableInput
#define _H_JXFloatTableInput

#include <JXFloatInput.h>

class JXEditTable;

class JXFloatTableInput : public JXFloatInput
{
public:

	JXFloatTableInput(JXEditTable* table, const JCharacter* fontName,
					  const JSize fontSize, const JFontStyle& fontStyle,
					  JXContainer* enclosure,
					  const HSizingOption hSizing, const VSizingOption vSizing,
					  const JCoordinate x, const JCoordinate y,
					  const JCoordinate w, const JCoordinate h);

	virtual ~JXFloatTableInput();

	virtual void	HandleKeyPress(const int key, const JXKeyModifiers& modifiers);

protected:

	virtual void	DrawBorder(JXWindowPainter& p, const JRect& frame);

	virtual void	TEClipboardChanged();

private:

	JXEditTable*	itsTable;		// the table owns us

private:

	// not allowed

	JXFloatTableInput(const JXFloatTableInput& source);
	const JXFloatTableInput& operator=(const JXFloatTableInput& source);
};

#endif
