/******************************************************************************
 JXIconMenuDirector.h

	Interface for the JXIconMenuDirector class

	Copyright  1996 by John Lindal. All rights reserved.

 ******************************************************************************/

#ifndef _H_JXIconMenuDirector
#define _H_JXIconMenuDirector

#include <JXMenuDirector.h>

class JXMenu;
class JXIconMenuData;

class JXIconMenuDirector : public JXMenuDirector
{
public:

	JXIconMenuDirector(JXDirector* supervisor,
					   JXMenu* menu, JXIconMenuData* menuData);

	virtual ~JXIconMenuDirector();

protected:

	virtual JXMenuTable*	CreateMenuTable();

	JXMenu*			GetMenu();
	JXIconMenuData*	GetMenuData();

private:

	// We don't own these objects.  We only save their values
	// for use in CreateMenuTable().

	JXMenu*			itsMenu;
	JXIconMenuData*	itsMenuData;

private:

	// not allowed

	JXIconMenuDirector(const JXIconMenuDirector& source);
	const JXIconMenuDirector& operator=(const JXIconMenuDirector& source);
};


/******************************************************************************
 GetMenu (protected)

 ******************************************************************************/

inline JXMenu*
JXIconMenuDirector::GetMenu()
{
	return itsMenu;
}

/******************************************************************************
 GetMenuData (protected)

 ******************************************************************************/

inline JXIconMenuData*
JXIconMenuDirector::GetMenuData()
{
	return itsMenuData;
}

#endif
