/******************************************************************************
 JXIconMenuTable.h

	Interface for the JXIconMenuTable class

	Copyright  1996 by John Lindal. All rights reserved.

 ******************************************************************************/

#ifndef _H_JXIconMenuTable
#define _H_JXIconMenuTable

#include <JXMenuTable.h>
#include <jXConstants.h>	// need definition of kJXDefaultBorderWidth

class JXIconMenuData;

class JXIconMenuTable : public JXMenuTable
{
public:

	enum
	{
		kHilightBorderWidth = kJXDefaultBorderWidth
	};

public:

	JXIconMenuTable(JXMenu* menu, JXIconMenuData* data, JXContainer* enclosure,
					const HSizingOption hSizing, const VSizingOption vSizing,
					const JCoordinate x, const JCoordinate y,
					const JCoordinate w, const JCoordinate h);

	virtual ~JXIconMenuTable();

protected:

	virtual void	TableDrawCell(JPainter& p, const JPoint& cell, const JRect& rect);

	virtual JBoolean	CellToItemIndex(const JPoint& cell, JIndex* itemIndex) const;
	virtual void		MenuHilightItem(const JIndex itemIndex);
	virtual void		MenuUnhilightItem(const JIndex itemIndex);
	virtual void		GetSubmenuPoints(const JIndex itemIndex,
										 JPoint* leftPt, JPoint* rightPt);

	virtual void	Receive(JBroadcaster* sender, const Message& message);

private:

	const JXIconMenuData*	itsIconMenuData;
	JBoolean				itsHasCheckboxesFlag;
	JBoolean				itsHasSubmenusFlag;
	JPoint					itsHilightCell;

private:

	JPoint	ItemIndexToCell(const JIndex itemIndex) const;

	// not allowed

	JXIconMenuTable(const JXIconMenuTable& source);
	const JXIconMenuTable& operator=(const JXIconMenuTable& source);
};

#endif
