/******************************************************************************
 JXIntegerTableInput.h

	Interface for the JXIntegerTableInput class

	Copyright  1996 by John Lindal. All rights reserved.

 ******************************************************************************/

#ifndef _H_JXIntegerTableInput
#define _H_JXIntegerTableInput

#include <JXIntegerInput.h>

class JXEditTable;

class JXIntegerTableInput : public JXIntegerInput
{
public:

	JXIntegerTableInput(JXEditTable* table, const JCharacter* fontName,
						const JSize fontSize, const JFontStyle& fontStyle,
						JXContainer* enclosure,
						const HSizingOption hSizing, const VSizingOption vSizing,
						const JCoordinate x, const JCoordinate y,
						const JCoordinate w, const JCoordinate h);

	virtual ~JXIntegerTableInput();

	virtual void	HandleKeyPress(const int key, const JXKeyModifiers& modifiers);

protected:

	virtual void	DrawBorder(JXWindowPainter& p, const JRect& frame);

	virtual void	TEClipboardChanged();

private:

	JXEditTable*	itsTable;		// the table owns us

private:

	// not allowed

	JXIntegerTableInput(const JXIntegerTableInput& source);
	const JXIntegerTableInput& operator=(const JXIntegerTableInput& source);
};

#endif
