/******************************************************************************
 JXPSPageSetupDialog.h

	Interface for the JXPSPageSetupDialog class

	Copyright  1996 by John Lindal. All rights reserved.

 ******************************************************************************/

#ifndef _H_JXPSPageSetupDialog
#define _H_JXPSPageSetupDialog

#include <JXDialogDirector.h>
#include <JXPSPrinter.h>

class JXTextMenu;
class JXRadioGroup;

class JXPSPageSetupDialog : public JXDialogDirector
{
public:

	JXPSPageSetupDialog(JXWindowDirector* supervisor,
						const JPSPrinter::PaperType paper,
						const JPSPrinter::ImageOrientation orient);

	virtual ~JXPSPageSetupDialog();

	JBoolean	SetParameters(JXPSPrinter* p) const;

protected:

	virtual void	Receive(JBroadcaster* sender, const Message& message);

private:

	JIndex	itsPaperType;

// begin JXLayout

    JXRadioGroup* itsOrientation;
    JXTextMenu*   itsPaperTypeMenu;

// end JXLayout

private:

	void	BuildWindow(const JPSPrinter::PaperType paper,
						const JPSPrinter::ImageOrientation orient);

	void	UpdatePaperTypeMenu();
	void	HandlePaperTypeMenu(const JIndex item);

	// not allowed

	JXPSPageSetupDialog(const JXPSPageSetupDialog& source);
	const JXPSPageSetupDialog& operator=(const JXPSPageSetupDialog& source);
};

#endif
