/******************************************************************************
 JXPathHistoryMenu.h

	Interface for the JXPathHistoryMenu class

	Copyright  1998 by John Lindal. All rights reserved.

 ******************************************************************************/

#ifndef _H_JXPathHistoryMenu
#define _H_JXPathHistoryMenu

#include <JXStringHistoryMenu.h>

class JXPathHistoryMenu : public JXStringHistoryMenu
{
public:

	JXPathHistoryMenu(const JSize historyLength,
					  const JCharacter* title, JXContainer* enclosure,
					  const HSizingOption hSizing, const VSizingOption vSizing,
					  const JCoordinate x, const JCoordinate y,
					  const JCoordinate w, const JCoordinate h);

	JXPathHistoryMenu(const JSize historyLength,
					  JXMenu* owner, const JIndex itemIndex, JXContainer* enclosure);

	virtual ~JXPathHistoryMenu();

protected:

	virtual void	Receive(JBroadcaster* sender, const Message& message);

private:

	JXImage*	itsDirIcon;

private:

	void	JXPathHistoryMenuX();
	void	RemoveInvalidPaths();
	void	ShowIcon();

	// not allowed

	JXPathHistoryMenu(const JXPathHistoryMenu& source);
	const JXPathHistoryMenu& operator=(const JXPathHistoryMenu& source);
};

#endif
