/******************************************************************************
 JXPrintPlainTextDialog.h

	Interface for the JXPrintPlainTextDialog class

	Copyright  1996 by John Lindal. All rights reserved.

 ******************************************************************************/

#ifndef _H_JXPrintPlainTextDialog
#define _H_JXPrintPlainTextDialog

#include <JXDialogDirector.h>

class JString;
class JXStringInput;
class JXIntegerInput;

class JXPrintPlainTextDialog : public JXDialogDirector
{
public:

	JXPrintPlainTextDialog(JXDirector* supervisor, const JCharacter* printCmd,
						   const JSize minLineCount, const JSize lineCountPerPage);

	virtual ~JXPrintPlainTextDialog();

	void	GetSettings(JString* printCmd, JSize* lineCountPerPage) const;

private:

// begin JXLayout

    JXStringInput*  itsPrintCmd;
    JXIntegerInput* itsLinesPerPageInput;

// end JXLayout

private:

	void	BuildWindow(const JCharacter* printCmd,
						const JSize minLineCount, const JSize lineCountPerPage);

	// not allowed

	JXPrintPlainTextDialog(const JXPrintPlainTextDialog& source);
	const JXPrintPlainTextDialog& operator=(const JXPrintPlainTextDialog& source);
};

#endif
