/******************************************************************************
 JXStringHistoryMenu.h

	Interface for the JXStringHistoryMenu class

	Copyright  1997 by John Lindal. All rights reserved.

 ******************************************************************************/

#ifndef _H_JXStringHistoryMenu
#define _H_JXStringHistoryMenu

#include <JXTextMenu.h>

class JXStringHistoryMenu : public JXTextMenu
{
public:

	JXStringHistoryMenu(const JSize historyLength,
						const JCharacter* title, JXContainer* enclosure,
						const HSizingOption hSizing, const VSizingOption vSizing,
						const JCoordinate x, const JCoordinate y,
						const JCoordinate w, const JCoordinate h);

	JXStringHistoryMenu(const JSize historyLength,
						JXMenu* owner, const JIndex itemIndex, JXContainer* enclosure);

	virtual ~JXStringHistoryMenu();

	JSize	GetHistoryLength() const;
	void	SetHistoryLength(const JSize historyLength);
	void	ClearHistory();

	void	AddString(const JCharacter* str);

	void	ReadSetup(istream& input);
	void	WriteSetup(ostream& output) const;

private:

	JSize	itsHistoryLength;

private:

	void	JXStringHistoryMenuX(const JSize historyLength);
	void	AdjustLength();

	// not allowed

	JXStringHistoryMenu(const JXStringHistoryMenu& source);
	const JXStringHistoryMenu& operator=(const JXStringHistoryMenu& source);
};


/******************************************************************************
 GetHistoryLength

 ******************************************************************************/

inline JSize
JXStringHistoryMenu::GetHistoryLength()
	const
{
	return itsHistoryLength;
}

/******************************************************************************
 ClearHistory

 ******************************************************************************/

inline void
JXStringHistoryMenu::ClearHistory()
{
	RemoveAllItems();
	Deactivate();
}

#endif
