/******************************************************************************
 JXStringInput.h

	Interface for the JXStringInput class

	Copyright  1996 by John Lindal. All rights reserved.

 ******************************************************************************/

#ifndef _H_JXStringInput
#define _H_JXStringInput

#include <JXInputField.h>

class JXStringInput : public JXInputField
{
public:

	JXStringInput(JXContainer* enclosure,
				  const HSizingOption hSizing, const VSizingOption vSizing,
				  const JCoordinate x, const JCoordinate y,
				  const JCoordinate w, const JCoordinate h);

	JXStringInput(const JBoolean wordWrap, const JBoolean acceptNewline,
				  JXContainer* enclosure,
				  const HSizingOption hSizing, const VSizingOption vSizing,
				  const JCoordinate x, const JCoordinate y,
				  const JCoordinate w, const JCoordinate h);

	virtual ~JXStringInput();

	const JString&	GetString() const;
	void			SetString(const JCharacter* str);

private:

	// not allowed

	JXStringInput(const JXStringInput& source);
	const JXStringInput& operator=(const JXStringInput& source);
};

/******************************************************************************
 GetString

 ******************************************************************************/

inline const JString&
JXStringInput::GetString()
	const
{
	return GetText();
}

/******************************************************************************
 SetString

 ******************************************************************************/

inline void
JXStringInput::SetString
	(
	const JCharacter* str
	)
{
	SetText(str);
}

#endif
