/******************************************************************************
 JXStringTableInput.h

	Interface for the JXStringTableInput class

	Copyright  1996 by John Lindal. All rights reserved.

 ******************************************************************************/

#ifndef _H_JXStringTableInput
#define _H_JXStringTableInput

#include <JXStringInput.h>

class JXEditTable;

class JXStringTableInput : public JXStringInput
{
public:

	JXStringTableInput(JXEditTable* table, const JCharacter* fontName,
					   const JSize fontSize, const JFontStyle& fontStyle,
					   JXContainer* enclosure,
					   const HSizingOption hSizing, const VSizingOption vSizing,
					   const JCoordinate x, const JCoordinate y,
					   const JCoordinate w, const JCoordinate h);

	virtual ~JXStringTableInput();

	virtual void	HandleKeyPress(const int key, const JXKeyModifiers& modifiers);

protected:

	JXEditTable*	GetTable() const;

	virtual void	DrawBorder(JXWindowPainter& p, const JRect& frame);

	virtual void	TEClipboardChanged();

private:

	JXEditTable*	itsTable;		// the table owns us

private:

	// not allowed

	JXStringTableInput(const JXStringTableInput& source);
	const JXStringTableInput& operator=(const JXStringTableInput& source);
};


/******************************************************************************
 GetTable

 ******************************************************************************/

inline JXEditTable*
JXStringTableInput::GetTable()
	const
{
	return itsTable;
}

#endif
